Overview | Package | Class | Tree | Deprecated | Index | Help
| ej-technologies
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.gjt.jclasslib.structures.attributes
Class CodeAttribute

    java.lang.Object
      org.gjt.jclasslib.structures.AbstractStructure
          org.gjt.jclasslib.structures.AbstractStructureWithAttributes
              org.gjt.jclasslib.structures.AttributeInfo
                  org.gjt.jclasslib.structures.attributes.CodeAttribute

public class CodeAttribute
extends AttributeInfo

Describes a `Code` attribute structure.

Version:
  $Revision: 1.4 $ $Date: 2003/08/18 07:52:05 $
Author:
  Ingo Kegel

Field Summary
`static String` | `ATTRIBUTE_NAME` Name of the attribute as in the corresponding constant pool entry.

Fields inherited from class org.gjt.jclasslib.structures.AttributeInfo
`SYSTEM_PROPERTY_SKIP_ATTRIBUTES`

Fields inherited from class org.gjt.jclasslib.structures.AbstractStructureWithAttributes
`attributes`

Fields inherited from class org.gjt.jclasslib.structures.AbstractStructure
`classFile, debug, SYSTEM_PROPERTY_DEBUG`

Constructor Summary
`CodeAttribute()`

Method Summary
`protected void` | `debug(String message)` Utility method for derived structures.
`int` | `getAttributeLength()` Get the length of this attribute as a number of bytes.
`byte[]` | `getCode()` Get the code of this code attribute as an array of bytes .
`ExceptionTableEntry[]` | `getExceptionTable()` Get the exception table of this code attribute as an array of `ExceptionTableEntry` elements.
`int` | `getMaxLocals()` Get the maximum number of local variables of this code attribute.
`int` | `getMaxStack()` Get the maximum stack depth of this code attribute.
`void` | `read(DataInput in)` Read this structure from the given `DataInput`.
`void` | `setCode(byte[] code)` Set the code of this code attribute as an array of bytes .
`void` | `setExceptionTable(ExceptionTableEntry[] exceptionTable)` Set the exception table of this code attribute as an array of `ExceptionTableEntry` elements.
`void` | `setMaxLocals(int maxLocals)` Set the maximum number of local variables of this code attribute.
`void` | `setMaxStack(int maxStack)` Set the maximum stack depth of this code attribute.
`void` | `write(DataOutput out)` Write this structure to the given `DataOutput`.

Methods inherited from class org.gjt.jclasslib.structures.AttributeInfo
`createOrSkip, getAttributeNameIndex, getInfo, getName, printAccessFlagsVerbose, setAttributeNameIndex, setInfo`

Methods inherited from class org.gjt.jclasslib.structures.AbstractStructureWithAttributes
`findAttribute, getAttributes, getTotalAttributesLength, readAttributes, setAttributes, writeAttributes`

Methods inherited from class org.gjt.jclasslib.structures.AbstractStructure
`getClassFile, getDebug, getLength, printAccessFlags, printAccessFlagsVerbose, printBytes, setClassFile, setDebug`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ATTRIBUTE_NAME

    public static final String ATTRIBUTE_NAME

  Name of the attribute as in the corresponding constant pool entry.

  See Also:
    Constant Field Values

Constructor Detail

### CodeAttribute

    public CodeAttribute()

Method Detail

### getMaxStack

    public int getMaxStack()

  Get the maximum stack depth of this code attribute.

  Returns:
    the stack depth

### setMaxStack

    public void setMaxStack(int maxStack)

  Set the maximum stack depth of this code attribute.

  Parameters:
    `maxStack` - the stack depth

### getMaxLocals

    public int getMaxLocals()

  Get the maximum number of local variables of this code attribute.

  Returns:
    the maximum number

### setMaxLocals

    public void setMaxLocals(int maxLocals)

  Set the maximum number of local variables of this code attribute.

  Parameters:
    `maxLocals` - the maximum number

### getCode

    public byte[] getCode()

  Get the code of this code attribute as an array of bytes .

  Returns:
    the array

### setCode

    public void setCode(byte[] code)

  Set the code of this code attribute as an array of bytes .

  Parameters:
    `code` - the array

### getExceptionTable

    public ExceptionTableEntry[] getExceptionTable()

  Get the exception table of this code attribute as an array of `ExceptionTableEntry` elements.

  Returns:
    the array

### setExceptionTable

    public void setExceptionTable(ExceptionTableEntry[] exceptionTable)

  Set the exception table of this code attribute as an array of `ExceptionTableEntry` elements.

  Parameters:
    `exceptionTable` - the array

### read

    public void read(DataInput in)
              throws InvalidByteCodeException,
                     IOException

  Description copied from class: `AbstractStructure`
  Read this structure from the given `DataInput`.

  Excpects `DataInput` to be in JVM class file format and just before a structure of this kind. No look ahead parsing since the class file format is deterministic.

  Overrides:
    `read` in class `AttributeInfo`
  Throws:
    `InvalidByteCodeException`
    `IOException`

### write

    public void write(DataOutput out)
               throws InvalidByteCodeException,
                      IOException

  Description copied from class: `AbstractStructure`
  Write this structure to the given `DataOutput`.

  The written bytes are in JVM class file format.

  Overrides:
    `write` in class `AttributeInfo`
  Throws:
    `InvalidByteCodeException`
    `IOException`

### getAttributeLength

    public int getAttributeLength()

  Description copied from class: `AttributeInfo`
  Get the length of this attribute as a number of bytes.

  Overrides:
    `getAttributeLength` in class `AttributeInfo`
  Returns:
    the length

### debug

    protected void debug(String message)

  Description copied from class: `AbstractStructure`
  Utility method for derived structures. Dump a specific debug message.

  Overrides:
    `debug` in class `AbstractStructure`
  Parameters:
    `message` - the debug message

Overview | Package | Class | Tree | Deprecated | Index | Help
| ej-technologies
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD